#!/usr/bin/env python3
## -*- encoding:utf-8 -*-
from tkinter import *
from tkinter import font
import string

'''
Programmname: translator.pyw
Funktion:     Uebersetzt eine Nukleinsaeure-Sequenz in eine Aminosaeure-Sequenz
Autor:        Herr Jakob 2009
'''

####################################################################
##                              Daten                             ##
####################################################################

TRIPLETT_DICTIONARY={
'UUU':['Phe', 'Phenylalanin'],          'UUC':['Phe', 'Phenylalanin'],          'UUA':['Leu', 'Leucin'],                'UUG':['Leu', 'Leucin'],
'CUU':['Leu', 'Leucin'],                'CUC':['Leu', 'Leucin'],                'CUA':['Leu', 'Leucin'],                'CUG':['Leu', 'Leucin'],
'AUU':['Ile', 'Isoleucin'],             'AUC':['Ile', 'Isoleucin'],             'AUA':['Ile', 'Isoleucin'],             'AUG':['Met/Start', 'Methionin/Start'],
'GUU':['Val', 'Valin'],                 'GUC':['Val', 'Valin'],                 'GUA':['Val', 'Valin'],                 'GUG':['Val', 'Valin'],
'UCU':['Ser', 'Serin'],                 'UCC':['Ser', 'Serin'],                 'UCA':['Ser', 'Serin'],                 'UCG':['Ser', 'Serin'],
'CCU':['Pro', 'Prolin'],                'CCC':['Pro', 'Prolin'],                'CCA':['Pro', 'Prolin'],                'CCG':['Pro', 'Prolin'],
'ACU':['Thr', 'Threonin'],              'ACC':['Thr', 'Threonin'],              'ACA':['Thr', 'Threonin'],              'ACG':['Thr', 'Threonin'],
'GCU':['Ala', 'Alanin'],                'GCC':['Ala', 'Alanin'],                'GCA':['Ala', 'Alanin'],                'GCG':['Ala', 'Alanin'],
'UAU':['Tyr', 'Tyrosin'],               'UAC':['Tyr', 'Tyrosin'],               'UAA':['Stop', 'Stop'],                 'UAG':['Stop', 'Stop'],
'CAU':['His', 'Histidin'],              'CAC':['His', 'Histidin'],              'CAA':['Gln', 'Glutamin'],              'CAG':['Gln', 'Glutamin'],
'AAU':['Asn', 'Asparagin'],             'AAC':['Asn', 'Asparagin'],             'AAA':['Lys', 'Lysin'],                 'AAG':['Lys', 'Lysin'],
'GAU':['Asp', 'Asparagins\u00E4ure'],   'GAC':['Asp', 'Asparagins\u00E4ure'],   'GAA':['Glu', 'Glutamins\u00E4ure'],    'GAG':['Glu', 'Glutamins\u00E4ure'],
'UGU':['Cys', 'Cystein'],               'UGC':['Cys', 'Cystein'],               'UGA':['Stop', 'Stop'],                 'UGG':['Trp', 'Tryptophan'],
'CGU':['Arg', 'Arginin'],               'CGC':['Arg', 'Arginin'],               'CGA':['Arg', 'Arginin'],               'CGG':['Arg', 'Arginin'],
'AGU':['Ser', 'Serin'],                 'AGC':['Ser', 'Serin'],                 'AGA':['Arg', 'Arginin'],               'AGG':['Arg', 'Arginin'],
'GGU':['Gly', 'Glycin'],                'GGC':['Gly', 'Glycin'],                'GGA':['Gly', 'Glycin'],                'GGG':['Gly', 'Glycin']
}

AS_DICTIONARY={
'Ala':'A',      'Cys':'C',  'Asp':'D',          'Glu':'E',
'Phe':'F',      'Gly':'G',  'His':'H',          'Ile':'I',
'Lys':'K',      'Leu':'L',  'Met/Start':'M',    'Asn':'N',
'Pro':'P',      'Gln':'Q',  'Arg':'R',          'Ser':'S',
'Thr':'T',      'Val':'V',  'Trp':'W',          'Tyr':'Y',
'Stop':'Stop'
}

####################################################################
##                            Funktionen                          ##
####################################################################

def eingabe_testen():
    a=v.get()
    if a == 'dna_codogen_revers':
        entry1r.config(state=NORMAL)
        entry1r.delete(0, END)
        entry1.delete(0, END)
        entry2.delete(0, END)
        entry3.delete(0, END)
        entry1.config(state=DISABLED)
        entry2.config(state=DISABLED)
        entry3.config(state=DISABLED)
    elif a == 'dna_codogen':
        entry1.config(state=NORMAL)
        entry1r.delete(0, END)
        entry1.delete(0, END)
        entry2.delete(0, END)
        entry3.delete(0, END)
        entry1r.config(state=DISABLED)
        entry2.config(state=DISABLED)
        entry3.config(state=DISABLED)
    elif a == 'dna_codestrang':
        entry2.config(state=NORMAL)
        entry1r.delete(0, END)
        entry1.delete(0, END)
        entry2.delete(0, END)
        entry3.delete(0, END)
        entry1r.config(state=DISABLED)
        entry1.config(state=DISABLED)
        entry3.config(state=DISABLED)
    elif a == 'rna_mrna':
        entry3.config(state=NORMAL)
        entry1r.delete(0, END)
        entry1.delete(0, END)
        entry2.delete(0, END)
        entry3.delete(0, END)
        entry1r.config(state=DISABLED)
        entry1.config(state=DISABLED)
        entry2.config(state=DISABLED)

# Funktionen zum Umwandeln
def dnareverse2dna(a):
    return a[::-1]

def dna2rna(a):
    if a == 'A':
        a='U'
    elif a == 'T':
        a='A'
    elif a == 'G':
        a='C'
    elif a == 'C':
        a='G'
    else:
        a='Fehler'
    return a

def rna2dna(a):
    if a == 'U':
        a='A'
    elif a == 'A':
        a='T'
    elif a == 'C':
        a='G'
    elif a == 'G':
        a='C'
    else:
        a='Fehler'
    return a

def dna2dnakompl(a):
    if a == 'A':
        a='T'
    elif a == 'T':
        a='A'
    elif a == 'G':
        a='C'
    elif a == 'C':
        a='G'
    else:
        a='Fehler'
    return a

def dnakompl2rna(a):
    if a == 'A':
        a='A'
    elif a == 'T':
        a='U'
    elif a == 'G':
        a='G'
    elif a == 'C':
        a='C'
    else:
        a='Fehler'
    return a

def rna2dnakompl(a):
    if a == 'A':
        a='A'
    elif a == 'U':
        a='T'
    elif a == 'G':
        a='G'
    elif a == 'C':
        a='C'
    else:
        a='Fehler'
    return a

def rna_kontrolle(a):
    if a == 'A':
        a='A'
    elif a == 'U':
        a='U'
    elif a == 'G':
        a='G'
    elif a == 'C':
        a='C'
    else:
        a='Fehler'
    return a

def liste_a_2_liste_b(a, sekfunktion):
    b=[]
    for i in a:
        i=sekfunktion(i)
        if i != 'Fehler':
            b.append(i)
    return b

def string2liste(a):
    b=[]
    for i in a:
        b.append(i)
    return b

def rna2prot(a):
    RNA_LISTE_LAENGE=int(len(a))
    MELDUNG_1=str('mRNA Sequenz-Laenge:\t'+str(RNA_LISTE_LAENGE))
    REST=RNA_LISTE_LAENGE % 3
    MELDUNG_2=str('Rest:\t'+str(REST))
    MELDUNG_FEHLER=''
    if REST==0:
        AS_ANZAHL=int(RNA_LISTE_LAENGE/3)
    else:
        AS_ANZAHL=int(RNA_LISTE_LAENGE/3)
        MELDUNG_FEHLER=str('Nicht ohne Rest durch 3 teilbar')
    MELDUNG_3=str(u'Triplett-Anzahl:\t'+str(AS_ANZAHL))
    TRIPLETT_LISTE=[]
    for i in range(0, int(AS_ANZAHL)):
        TRIPLETT='%s%s%s' % (a[int(3*i)], a[int(3*i+1)], a[int(3*i+2)])
        TRIPLETT_LISTE.append(TRIPLETT)
        i=i+1
    AS_LISTE=[]
    for i in TRIPLETT_LISTE:
        AS=TRIPLETT_DICTIONARY[i][0]
        AS_LISTE.append(AS)
    MELDUNG='%s\n%s\n%s\n%s' % (MELDUNG_1, MELDUNG_2, MELDUNG_FEHLER, MELDUNG_3)
    return AS_LISTE, MELDUNG

def drei2eins(a):
    EINS_LISTE=[]
    for i in a:
        EINS=AS_DICTIONARY[i]
        EINS_LISTE.append(EINS)
    return EINS_LISTE

def liste2string(a, TRENNZEICHEN):
    #zeichenkette=string.join(a, TRENNZEICHEN)
    zeichenkette=TRENNZEICHEN.join(a)
    return zeichenkette

## Hauptfunktion
def ermitteln():
    a=v.get()
    ############################### Transkription #############################
    ## Fall 0: Reverser Codogener DNA-Strang ist gegeben
    if a == 'dna_codogen_revers':
        DNA_CODOGEN_REVERS=entry1r.get()
        DNA_CODOGEN_REVERS=DNA_CODOGEN_REVERS.upper()
        DNA_CODOGEN_REVERS=DNA_CODOGEN_REVERS.strip()
        entry1r.delete(0, END)
        entry1r.insert(0, DNA_CODOGEN_REVERS)
        # Reversen Strang in den "normalen" umwandeln
        DNA_CODOGEN=dnareverse2dna(DNA_CODOGEN_REVERS)
        entry1.config(state=NORMAL)
        entry1.delete(0, END)
        entry1.insert(0, DNA_CODOGEN)
        # DNA codogen in Liste
        DNA_CODOGEN_LISTE=string2liste(DNA_CODOGEN)
        # Umwandeln in DNA Leitstrang
        DNA_CODOGEN_LISTE_1=DNA_CODOGEN_LISTE[:]   # Kopie 1
        DNA_LEITSTRANG_LISTE=liste_a_2_liste_b(DNA_CODOGEN_LISTE_1, dna2dnakompl)
        DNA_LEITSTRANG_STRING=''.join(DNA_LEITSTRANG_LISTE)
        entry2.config(state=NORMAL)
        entry2.delete(0, END)
        entry2.insert(0, DNA_LEITSTRANG_STRING)
        # Umwandeln in RNA
        DNA_CODOGEN_LISTE_2=DNA_CODOGEN_LISTE[:]   # Kopie 2
        RNA_LISTE=liste_a_2_liste_b(DNA_CODOGEN_LISTE_2, dna2rna)
        RNA_STRING=''.join(RNA_LISTE)
        entry3.config(state=NORMAL)
        entry3.delete(0, END)
        entry3.insert(0, RNA_STRING)

    ## Fall 1: Codogener DNA-Strang ist gegeben
    if a == 'dna_codogen':
        DNA_CODOGEN=entry1.get()
        DNA_CODOGEN=DNA_CODOGEN.upper()
        DNA_CODOGEN=DNA_CODOGEN.strip()
        entry1.delete(0, END)
        entry1.insert(0, DNA_CODOGEN)
        # DNA codogen in Liste
        DNA_CODOGEN_LISTE=string2liste(DNA_CODOGEN)
        # Umwandeln in DNA Leitstrang
        DNA_CODOGEN_LISTE_1=DNA_CODOGEN_LISTE[:]   # Kopie 1
        DNA_LEITSTRANG_LISTE=liste_a_2_liste_b(DNA_CODOGEN_LISTE_1, dna2dnakompl)
        DNA_LEITSTRANG_STRING=''.join(DNA_LEITSTRANG_LISTE)
        entry2.config(state=NORMAL)
        entry2.delete(0, END)
        entry2.insert(0, DNA_LEITSTRANG_STRING)
        # Umwandeln in RNA
        DNA_CODOGEN_LISTE_2=DNA_CODOGEN_LISTE[:]   # Kopie 2
        RNA_LISTE=liste_a_2_liste_b(DNA_CODOGEN_LISTE_2, dna2rna)
        RNA_STRING=''.join(RNA_LISTE)
        entry3.config(state=NORMAL)
        entry3.delete(0, END)
        entry3.insert(0, RNA_STRING)

    # Fall 2: DNA-Codestrang ist gegeben
    if a == 'dna_codestrang':
        DNA_LEITSTRANG=entry2.get()
        DNA_LEITSTRANG=DNA_LEITSTRANG.upper()
        DNA_LEITSTRANG=DNA_LEITSTRANG.strip()
        entry2.delete(0, END)
        entry2.insert(0, DNA_LEITSTRANG)
        # DNA Leitstrang in Liste
        DNA_LEITSTRANG_LISTE=string2liste(DNA_LEITSTRANG)
        # Umwandeln in codogenen DNA Strang
        DNA_LEITSTRANG_LISTE_1=DNA_LEITSTRANG_LISTE[:]   # Kopie 1
        DNA_CODOGEN_LISTE=liste_a_2_liste_b(DNA_LEITSTRANG_LISTE_1, dna2dnakompl)
        DNA_CODOGEN_STRING=''.join(DNA_CODOGEN_LISTE)
        entry1.config(state=NORMAL)
        entry1.delete(0, END)
        entry1.insert(0, DNA_CODOGEN_STRING)
        # Umwandeln DNA Leitstrang in RNA
        DNA_LEITSTRANG_LISTE_2=DNA_LEITSTRANG_LISTE[:]   # Kopie 2
        RNA_LISTE=liste_a_2_liste_b(DNA_LEITSTRANG_LISTE_2, dnakompl2rna)
        RNA_STRING=''.join(RNA_LISTE)
        entry3.config(state=NORMAL)
        entry3.delete(0, END)
        entry3.insert(0, RNA_STRING)

    # Fall 3: mRNA ist gegeben
    if a == 'rna_mrna':
        RNA=entry3.get()
        RNA=RNA.upper()
        RNA=RNA.strip()
        entry3.delete(0, END)
        entry3.insert(0, RNA)
        # mRNA in Liste
        RNA_LISTE=string2liste(RNA)
        RNA_LISTE=liste_a_2_liste_b(RNA_LISTE, rna_kontrolle)
        # Umwandeln in codogenen DNA Strang
        RNA_LISTE_1=RNA_LISTE[:]   # Kopie 1
        DNA_CODOGEN_LISTE=liste_a_2_liste_b(RNA_LISTE_1, rna2dna)
        DNA_CODOGEN_STRING=''.join(DNA_CODOGEN_LISTE)
        entry1.config(state=NORMAL)
        entry1.delete(0, END)
        entry1.insert(0, DNA_CODOGEN_STRING)
        # Umwandeln in DNA Leitstrang
        RNA_LISTE_2=RNA_LISTE[:]   # Kopie 2
        DNA_LEITSTRANG_LISTE=liste_a_2_liste_b(RNA_LISTE_2, rna2dnakompl)
        DNA_LEITSTRANG_STRING=''.join(DNA_LEITSTRANG_LISTE)
        entry2.config(state=NORMAL)
        entry2.delete(0, END)
        entry2.insert(0, DNA_LEITSTRANG_STRING)

    ############################### Translation #############################
    # mit Tripletts aus Daten-Dictionary vergleichen und Aminosaeure-Codes holen
    if a == 'X':
        RNA_LISTE=[]
    AS_LISTE=rna2prot(RNA_LISTE)[0]
    AS_STRING=liste2string(AS_LISTE, '-')
    entry4.config(state=NORMAL)
    entry4.delete(0, END)
    entry4.insert(0, AS_STRING)
    EINS_LISTE=drei2eins(AS_LISTE)
    EINS_STRING=liste2string(EINS_LISTE, '')
    entry5.config(state=NORMAL)
    entry5.delete(0, END)
    entry5.insert(0, EINS_STRING)
    MELDUNGEN=rna2prot(RNA_LISTE)[1]
    textfeld.config(state=NORMAL)
    textfeld.delete(1.0, END)
    textfeld.insert(1.0, MELDUNGEN)

def reset():
    for i in (entry1r, entry1, entry2, entry3, entry4, entry5):
        i.config(state=NORMAL)
        i.delete(0, END)
        i.config(state=DISABLED)
    textfeld.config(state=NORMAL)
    textfeld.delete(1.0, END)
    textfeld.config(state=DISABLED)
    for i in (radio1, radio2, radio3):
        v.set('X')

####################################################################
##                               GUI                              ##
####################################################################

## Fenster erzeugen
root=Tk()

# Schriften festlegen (vgl. Formatvorlagen)
monospacefont = font.Font(family='Courier New', 
                            size=12, 
                            weight='bold')

## Elemente erzeugen

# Rahmen
frame1=Frame(root)
frame2=Frame(root)

# Eingabe 
label0=Label(frame1,
             text=u'Nukleins\u00E4ure-Sequenz')
global v
v = StringVar()
v.set('X')
radio1r=Radiobutton(frame1, 
                    text=u'Codogener DNA-Strang r\u00FCckw\u00E4rts:', 
                    variable=v, 
                    value='dna_codogen_revers', 
                    command=eingabe_testen)
label1r=Label(frame1, 
             text="5'")
entry1r=Entry(frame1, 
             width=33,
             bg='white',
             font=monospacefont,
             state=DISABLED)
label2r=Label(frame1, text="3'")
radio1=Radiobutton(frame1, 
                   text='Codogener DNA-Strang:', 
                   variable=v, 
                   value='dna_codogen', 
                   command=eingabe_testen)
label1=Label(frame1, 
             text="3'")
entry1=Entry(frame1, 
             width=33,
             bg='white',
             font=monospacefont,
             state=DISABLED)
label2=Label(frame1, text="5'")
radio2=Radiobutton(frame1, 
                   text='DNA Code-Strang:', 
                   variable=v, 
                   value='dna_codestrang', 
                   command=eingabe_testen)
label3=Label(frame1, 
             text="5'")
entry2=Entry(frame1,
             width=33, 
             bg='white',
             font=monospacefont,
             state=DISABLED)
label4=Label(frame1, 
             text="3'")
radio3=Radiobutton(frame1, 
                   text='mRNA:', 
                   variable=v, 
                   value='rna_mrna', 
                   command=eingabe_testen)
label5=Label(frame1, 
             text="5'")
entry3=Entry(frame1, 
             width=33,
             bg='white',
             font=monospacefont,
             state=DISABLED)
label6=Label(frame1, 
             text="3'")

# Ausgabe
label7=Label(frame1, 
             text=u'Aminos\u00E4ure-Sequenz')
label8=Label(frame1,
             text='Dreibuchstabencode:')
entry4=Entry(frame1, 
             width=44,
             bg='white', 
             state=DISABLED)
label9=Label(frame1,
             text='Einbuchstabencode:')
entry5=Entry(frame1, 
             width=44,
             bg='white', 
             state=DISABLED)
label10=Label(frame1,
              text='Meldungen:')
textfeld=Text(frame1,
              width=44,
              height=4,
              bg='white',
              state=DISABLED,
              font=('Arial',))

# Steuerung
button1=Button(frame2,
               text=u'Aminos\u00E4ure-Sequenz ermitteln',
               command=ermitteln)
button2=Button(frame2,
               text=u'Zur\u00FCcksetzen',
               command=reset)
button3=Button(frame2,
               text='Beenden',
               command=root.destroy)

## Elemente anzeigen

# Rahmen
frame1.grid(row=0, column=0)
frame2.grid(row=1, column=0)

# Eingabe und Ausgabe
for i, row, column, sticky in (
        (label0,  0, 0, W),
        (radio1r, 1, 0, W), (label1r, 1, 1, W), (entry1r,   1, 2, EW), (label2r, 1, 3, W),
        (radio1,  2, 0, W), (label1,  2, 1, W), (entry1,    2, 2, EW), (label2,  2, 3, W),
        (radio2,  3, 0, W), (label3,  3, 1, W), (entry2,    3, 2, EW), (label4,  3, 3, W),
        (radio3,  4, 0, W), (label5,  4, 1, W), (entry3,    4, 2, EW), (label6,  4, 3, W),
        (label7,  5, 0, W), 
        (label8,  6, 0, W),                     (entry4,    6, 2, W),
        (label9,  7, 0, W),                     (entry5,    7, 2, W),
        (label10, 8, 0, W),                     (textfeld,  8, 2, W)):
    i.grid(row=row, column=column, sticky=sticky)

# Steuerung
for j, row, column in ((button1, 0, 0),(button2, 0, 1), (button3, 0, 2)):
    j.grid(row=row, column=column)


## Fenster in Hauptschleife anzeigen
root.title('Translator')
root.mainloop()
